//Copyright 2012-2013 Haley Abel
//
//This file is part of ClusterFAST.
//
//ClusterFAST is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//ClusterFAST is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with ClusterFAST.  If not, see <http://www.gnu.org/licenses/>.
import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Vector;
import java.util.Iterator;

import net.sf.samtools.SAMFileReader;
import net.sf.samtools.SAMFileWriter;
import net.sf.samtools.SAMFileWriterFactory;
import net.sf.samtools.SAMRecord;
import net.sf.samtools.SAMRecordIterator;
import net.sf.samtools.SAMFileReader.ValidationStringency;

import net.sf.picard.reference.FastaSequenceFile;
import net.sf.picard.reference.ReferenceSequenceFileWalker;
import net.sf.picard.reference.ReferenceSequence;

import net.sf.picard.filter.IntervalFilter;
import net.sf.picard.util.*;
import net.sf.samtools.*;


public class FindTrans_2 {

	
    
    public static void main(String[] argv) throws Exception
    {
		
        SAMFileReader inputSam=null;
        ReferenceSequenceFileWalker refwalker=null;
             
        String itxfile=null;
        boolean firstPass=true;
		int minct=1;
		String outdir=null;
		int round=1;
		int dist=50000;
		
		
        switch(argv.length) {
			

            case 6:
				round=new Integer(argv[5]).intValue();  
				if(round==2)
					firstPass=false;
				outdir=argv[4];
				dist=new Integer(argv[3]).intValue();
				minct=new Integer(argv[2]).intValue();
                itxfile=argv[1];
                inputSam=new SAMFileReader(new File(argv[0]));
  
                break;
                
            default:
                System.err.println("usage:\tjava FindTrans_2 input.bam interval_filter minct dist outdir round  \n");
                System.exit(1);
        }
        
		TxFinder_2 tx=new TxFinder_2(inputSam, itxfile, minct, dist, outdir, firstPass);
        tx.sortInputSam();
       
        if(firstPass) {
		
			int stepsize1=100;
			int tol1=2;
          
            tx.getClusterMap(stepsize1, tol1);			//don't change stepsize here, hard coded in qposmap2
            tx.printClusterMap();
            tx.getQPosMap(stepsize1);
            tx.filterSingleEnds(true);
			tx.filterOtherSingleEnds();
           // tx.filterSoftClips();
          
		}
		else {
			int stepsize2=100;
            int tol2=2;
			
            tx.getClusterMap(stepsize2, tol2);
            tx.printClusterMap();
            tx.getQPosMap(stepsize2);
			tx.dumpReads(stepsize2, tol2);
		}
        
    }
    
}




