//Copyright 2012-2013 Haley Abel
//
//This file is part of ClusterFAST.
//
//ClusterFAST is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//
//ClusterFAST is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with ClusterFAST.  If not, see <http://www.gnu.org/licenses/>.

import net.sf.picard.util.Interval;
import net.sf.samtools.SAMFileHeader;



public class Interval1 {

    private int intindex=-1;
    private int intstart=-1;
    private int intstop=-1;
    private String intname=null;
    private int dist=-1;
    private String regname=null;
    
    public Interval1() {
    }
    
    public Interval1 (Interval old_int, SAMFileHeader hd, int dst) {
        
        dist=dst;
        intindex=hd.getSequenceIndex(old_int.getSequence());
        intstart=old_int.getStart()-dist;
        intstop=old_int.getStart()+old_int.length()+dist;
        intname=old_int.getSequence();
        regname=old_int.getName();
    }
    
    public void print() {
        System.err.println(intname+"\t"+regname+"\t"+intindex+"\t"+intstart+"\t"+intstop);
    }
    
    public boolean contains(int ind, int pos) {
        return (ind==intindex && pos > intstart && pos < intstop);
    }
    
    public boolean contains(int ind, int pos, int tol) {
        return (ind==intindex && pos > (intstart-tol) && pos < (intstop+tol));
    }

        



    public String getName() {
        return intname;
    }

    public int getStop() {
        return intstop;
    }

    public int getStart() {
        return intstart;
    }

    public int getIndex() {
        return intindex;
    }
}